import java.net.*;
import java.io.*;
import ketai.sensors.*; 
JSONArray values;
String resultat;

double longitude, latitude, accuracy;
KetaiLocation location;

//Create mercator map object
MercatorMap mercatorMap;

//create PVector
PVector zone;
PVector local;
PImage chicago;

void setup() {
  size(displayWidth, displayHeight);

  //println(json);//or save it?
  //load the image object
  chicago = loadImage("chicago.png");

  //create the map/sketch coordinate translation
  mercatorMap = new MercatorMap(displayWidth, displayHeight, 42.04, 41.63, -87.92, -87.49);
}


void draw() {
    resultat   = getUrlContents("https://data.cityofchicago.org/resource/t2qc-9pjd.json");

  image(chicago, 0, 0, width, height);
  fill(255, 0, 0);  
  JSONArray json = JSONArray.parse(resultat);
  // println(json.size());
  for (int i = 0; i < json.size (); i++) {

    JSONObject congestion = json.getJSONObject(i); 


    Float lat = congestion.getFloat("_south");

    Float lon = congestion.getFloat("_west");
    Float speed = congestion.getFloat("current_speed");

    zone = mercatorMap.getScreenLocation(new PVector(lat, lon));

    ellipse (zone.x, zone.y, 30, 30);

    if (dist(mouseX, mouseY, zone.x, zone.y)< 20) {
      pushStyle();
      fill(0, 0, 0);
      textSize(32);
      text(speed, zone.x-40, zone.y-50);
      pushStyle();
    }
    if (speed < 20) {

      fill (255, 0, 0);
    } else 

      if (speed > 20) {
      fill(0, 255, 0);
    }
  }

  //Location info

  if (location.getProvider() == "none")
    text("Location data is unavailable. \n" +
      "Please check your location settings.", 0, 0, width, height);
  else
    text("Location data:\n" + 
    "Latitude: " + latitude + "\n" + 
    "Longitude: " + longitude, 20, 0, width, height);

  //Casting the doubles into floats
  float localat = (float)latitude;
  float localon = (float)longitude;
  fill(0, 0, 0);
  //convering the new location floats into PVectors so that we can calulate distances. 
  local = mercatorMap.getScreenLocation(new PVector(localat, localon));

  //Draw our location on the map
  ellipse(local.x, local.y, 40, 40);
}


//Ketai functions
void onResume()
{
  location = new KetaiLocation(this);
  super.onResume();
}

void onLocationEvent(Location _location)
{
  //print out the location object
  println("onLocation event: " + _location.toString());
  longitude = _location.getLongitude();
  latitude = _location.getLatitude();
}

